/*
libmatrix.c

matrix manipulation and algebra library
version 0.01
Peter A. Cejchan, GPL
Wed Mar 24 06:05:32 EST 2004 <cej@gli.cas.cz | pac7@post.cz | pac@plan9.cz>


*/


#include <u.h>
#include <libc.h>
#include <bio.h>
#include <ctype.h>
#include "libmatrix.h"

// functions:

int 
readmat(Matrix *mat){
	Biobuf bin;
	char *buf, *av[128];
	int i, j;

	Binit(&bin, 0, OREAD);
	i=0;
	while((buf = Brdstr(&bin, '\n', 1)) != nil){
		mat->cols=   tokenize(buf, av, MAXCOLS);
		for(j=0; j<mat->cols; j++){
			mat->x[i][j]=atof(av[j]);
		}
		free(buf);
		i++;
	}
	mat->rows=i;
	return 1;
}

int 
matmax(Matrix *mat){
	int i, j, maxi, maxj;
	double maxx;
	maxx = -MAXFLOAT;
	for(i=0; i<mat->rows; i++){
		for(j=0; j<mat->cols; j++){
//			print("%f ", mat->x[i][j]);
			if(mat->x[i][j] > maxx) {
				maxx = mat->x[i][j];
				maxi = i; maxj = j;
			}
		}
//		print("\n");
	}
//	print("%f\n", maxx);
	print("%d %d\n", maxi, maxj);
	return 1;
}

int 
mattranspose(Matrix *mat){
	Matrix tmp;
	int i, j;

	for(i=0; i<mat->rows; i++){
		for(j=0; j<mat->cols; j++){
			tmp.x[j][i] = mat->x[i][j];
		}
	}
	for(i=0; i<mat->rows; i++){
		for(j=0; j<mat->cols; j++){
			mat->x[i][j] = tmp.x[i][j];
		}
	}
	return 1;
}

void 
matmul(Matrix *a, Matrix *b){

//untested!!!

	int i, j, k;
	double sum;
	Matrix tmp;
	for(i=0;i<a->rows;i++) for(j=0;j<a->rows;j++){
		sum=0;
		for(k=0;k<a->cols;k++)
			sum+=a->x[i][k]*b->x[k][j];
		tmp.x[i][j]=sum;
	}
	for(i=0;i<a->rows;i++) for(j=0;j<a->rows;j++)
		a->x[i][j]=tmp.x[i][j];
}

int 
readvec(Vector *vec){
	Biobuf bin;
	char *buf, *av[128];
	int i, j;

	Binit(&bin, 0, OREAD);
	i=0;
	if((buf = Brdstr(&bin, '\n', 1)) != nil){
		vec->length=   tokenize(buf, av, MAXLENGTH);
		for(j=0; j<vec->length; j++){
			vec->x[j]=atof(av[j]);
		}
		free(buf);
	}
	return 1;
}

int 
readivec(iVector *vec){
	Biobuf bin;
	char *buf, *av[128];
	int i, j;

	Binit(&bin, 0, OREAD);
	i=0;
	if((buf = Brdstr(&bin, '\n', 1)) != nil){
		vec->length=   tokenize(buf, av, MAXLENGTH);
		for(j=0; j<vec->length; j++){
			vec->x[j]=atoi(av[j]);
		}
		free(buf);
	}
	return 1;
}


int
neighborpair(iVector *vec, iMatrix *mat){
	int i, j;
	for(i=0; i<mat->rows; i++){
		for(j=0; j<mat->cols; j++){
			mat->x[i][j]=0;
		}
	}
	for(i=0; i<vec->length-1; i++){
		mat->x[vec->x[i]][vec->x[i+1]]=0;
		mat->x[vec->x[i+1]][vec->x[i]]=0;
	}

}


