/*
libmatrix.h

matrix manipulation and algebra library
version 0.01
Peter A. Cejchan, GPL
Wed Mar 24 06:23:52 EST 2004 <cej@gli.cas.cz | pac7@post.cz | pac@plan9.cz>



*/
#define MAXROWS 100
#define MAXCOLS MAXROWS
#define MAXLENGTH MAXROWS
#define MAXFLOAT 1e20
typedef struct Matrix Matrix;
typedef struct iMatrix iMatrix;
typedef struct Vector Vector;
typedef struct iVector iVector;
typedef struct Couple Couple;

struct Matrix{
	int rows, cols;
	double x[MAXROWS][MAXCOLS];
};

struct iMatrix{
	int rows, cols;
	int x[MAXROWS][MAXCOLS];
};

struct Couple{
	int pred, succ;
};

struct cMatrix{
	int rows, cols;
	Couple x[MAXROWS][MAXCOLS];
};

struct Vector{
	int length;
	double x[MAXLENGTH];
};

struct iVector{
	int length;
	int x[MAXLENGTH];
};


int readmat(Matrix *mat);
int matmax(Matrix *mat);
int mattranspose(Matrix *mat);
void matmul(Matrix *a, Matrix *b);

int readvec(Vector *vec);
int readivec(iVector *vec);
int neighborpair(iVector *vec, iMatrix *mat);

